<?php

  include "igralec.php";

  function readlineX($sock) {
    static $buffer = "";
    while (strpos($buffer, "\n") === FALSE) {
      $rcv = socket_read($sock, 130);
      if ($rcv === FALSE) exit(0);
      $buffer .= $rcv;
    }
    $r = explode("\n", $buffer, 2);
    $buffer = $r[1];
    return rtrim($r[0]);
  }

  function connect($hostname) {
    $addr = gethostbyname($hostname);
    $sock = socket_create(AF_INET, SOCK_STREAM, 0);
    if ($sock < 0) return -1;

    $ret = socket_connect($sock, $addr, 1177);
    if ($ret < 0) return -1;

    $srv = readlineX($sock);
    echo $srv . "\n";

    $cmd = "AVE " . $GLOBALS['Ime'] . "\n";
    socket_write($sock, $cmd);

    $resp = readlineX($sock);
    if ($resp != "PRIJAVA USPESNA") return -1;

    return $sock;
  }

  function event_loop($sock) {
    global $barve;
    while (true) {
      $cmda = explode(" ", readlineX($sock));

      if ($cmda[0] == "ADIJO") return;
      if ($cmda[0] == "KONEC_IGRE") continue;
      if ($cmda[0] != "ZBUDI_SE") {
        echo "Napaka pri komunikaciji s streznikom.\n";
        return;
      }

      $P = new Polje($cmda[1], $cmda[2]);
      $Z = new Igralec;
      $Z->ZbudiSe($cmda[1], $cmda[2], $cmda[3]);
      socket_write($sock, "BUDEN\n");

      while (true) {
        $cmda = explode(" ", readlineX($sock));

        if ($cmda[0] == "ADIJO") return;
        else if ($cmda[0] == "KONEC_IGRE") {
          $Z->KonecIgre($cmda[1]);
          break;
        } else if ($cmda[0] == "QV") {
          $prejsnja_poteza = $cmda[1];
          $P->dodaj($prejsnja_poteza, $barve['bNasprotnik']);
          $Q = cpPolje($P);
          $poteza = $Z->KamGres($Q, $prejsnja_poteza);
          $P->dodaj($poteza, $barve['bJaz']);
          socket_write($sock, "QVR " . $poteza . "\n");
        }
      }
    }
  }

  // ---- main ----

  set_time_limit(0);

  if ($argc < 2) {
    $hostname = "localhost";
  } else {
    $hostname = $argv[1];
  }

  $sock = connect($hostname);
  if ($sock == -1) {
    echo "Povezava s streznikom ni uspela.\n";
    exit(-1);
  }
  event_loop($sock);

?>
