<?php

$barve = array( 'bPrazna' => '0', 'bJaz' => '1', 'bNasprotnik' => '-1' );

// Podatkovni tip Polje -- igralno polje za igro "4 v vrsto"
//
// uporaba:
//  $p = new Polje(13,17);              -- naredi novo polje dimenzij 13x17
//  $q = cpPolje($p);                      -- naredi novo polje, katerega dimenzije in barve celic so identicne polju p
//
//  $p->izpisi();                               -- izpise polje $p
//  $p->dodaj(2, $barve['bJaz']); -- najnizjo(!) prazno celico stolpca 2 pobarva z mojo barvo
//  $p->p(1,2, $barve['bNasprotnik']);   -- celico(1,2) pobarva z nasprotnikovo barvo
//  $b = $p->p(3,4);                        -- prebere barvo celice (3,4)

function cpPolje($orig) {
	$p = clone $orig;
	return $p;
}

class Polje {
	public $polje;
	public $sirina;
	public $visina;

	function __construct($_sirina, $_visina) {
		global $barve;
		$this->sirina = $_sirina;
		$this->visina = $_visina;
		$this->polje = array();
		for ($i=0;$i<$this->sirina;$i++) {
			for ($j=0;$j<$this->visina;$j++) {
				$this->polje[$i][$j] = $barve['bPrazna'];
			}
		}
	}
	
	function dodaj($stolpec, $barva) {
		global $barve;
		if ($stolpec == -1) return;
		for ($i=0;$i<$this->visina;$i++) {
			if ($this->polje[$stolpec][$i] == $barve['bPrazna']) {
				$this->polje[$stolpec][$i] = $barva;
				return;
			}
		}
		throw new Exception("Stolpec je ze poln.");
	}
	
	function izpisi() {
		global $barve;
		for ($y=$this->visina-1;$y>=0;$y--) {
			for ($x=0;$x<$this->sirina;$x++) {
				switch ($this->polje[$x][$y]) {
					case $barve['bPrazna']: printf(' '); break;
					case $barve['bJaz']: printf('*'); break;
					case $barve['bNasprotnik']: printf('o'); break;
				}
			}
			printf("\n");
		}
	}
	
	function p() {
		$params = func_get_args();
		if (func_num_args() == 2) {
			return $this->polje[func_get_arg(0)][func_get_arg(1)];
		} else if (func_num_args() == 3) {
			$this->polje[func_get_arg(0)][func_get_arg(1)] = func_get_arg(2);
		}
	}
}

?>
